<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\COZ\Services\DistribuicaoProducaoService;

class DistribuicaoProducaoController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $dataSourceManager;
    protected $distribuicaoProducaoService;
    protected $dataSourceName = "distribuicaoproducao";
    protected $parameterBagColumns = array(
    	"NRORG"
	);

	 public function __construct($crudService, $parameterBag, $dataSourceManager, $distribuicaoProducaoService) {
        $this->distribuicaoProducaoService = $distribuicaoProducaoService;
        $this->dataSourceManager = $dataSourceManager;
    	parent::__construct($crudService, $parameterBag);
    }

    public function retornaListaEtiquetas($cdcentral, $dtinicial, $dtfinal, $nrlistaserv, $listaproduto) {
        $filterCriteria = new FilterCriteria('pla10600_lista_etiquetas');
        $this->parameterBagColumns = array('CDCENTRAL', 'DTINICIAL', 'DTFINAL', 'NRLISTASERV', 'LISTAPRODUTO');
        $filterCriteria->addCondition('CDCENTRAL', $cdcentral);
        $filterCriteria->addCondition('DTINICIAL', $dtinicial);
        $filterCriteria->addCondition('DTFINAL', $dtfinal);
        $filterCriteria->addCondition('NRLISTASERV', $nrlistaserv);
        $filterCriteria->addCondition('LISTAPRODUTO', $listaproduto);
        $filterCriteria->setDataSourceName('pla10600_lista_etiquetas');
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $rows = $dataSet->getRows();
        
        $listaArray = [];
        foreach ($rows as $row) {
            for ($i = 0; $i < $row['QTCONTAINER']; $i++) {                
                $listaArray[] = $row['NREMBDISTCARD'] . '_' . $i; // Collect each key-value pair
            }
        }
        
        $uniqueListaArray = array_unique($listaArray);
        $lista = implode('-', $uniqueListaArray);
        
        return $lista;
    }


}